local __FILE__=tostring(debugstack(1,2,0):match("(.*):1:")) -- Always check line number in regexp and file, must be 1
--[===[@debug@
print('Loaded',__FILE__)
--@end-debug@]===]
local function pp(...) print(GetTime(),"|cff009900",__FILE__:sub(-15),strjoin(",",tostringall(...)),"|r") end
--*TYPE module
--*CONFIG profile=true,enhancedProfile=true
-- Auto Generated
local me,ns=...
if ns.die then return end
local addon=ns --#Addon (to keep eclipse happy)
ns=nil
local module=addon:NewSubModule('Data')  --#Module
function addon:GetDataModule() return module end
-- Template
local G=C_Garrison
local _
local AceGUI=LibStub("AceGUI-3.0")
local C=addon:GetColorTable()
local L=addon:GetLocale()
local new=addon:Wrap("NewTable")
local del=addon:Wrap("DelTable")
local kpairs=addon:Wrap("Kpairs")
local empty=addon:Wrap("Empty")

local todefault=addon:Wrap("todefault")

local tonumber=tonumber
local type=type
local OHF=OrderHallMissionFrame
local OHFMissionTab=OrderHallMissionFrame.MissionTab --Container for mission list and single mission
local OHFMissions=OrderHallMissionFrame.MissionTab.MissionList -- same as OrderHallMissionFrameMissions Call Update on this to refresh Mission Listing
local OHFFollowerTab=OrderHallMissionFrame.FollowerTab -- Contains model view
local OHFFollowerList=OrderHallMissionFrame.FollowerList -- Contains follower list (visible in both follower and mission mode)
local OHFFollowers=OrderHallMissionFrameFollowers -- Contains scroll list
local OHFMissionPage=OrderHallMissionFrame.MissionTab.MissionPage -- Contains mission description and party setup 
local OHFMapTab=OrderHallMissionFrame.MapTab -- Contains quest map
local OHFCompleteDialog=OrderHallMissionFrameMissions.CompleteDialog
local OHFMissionScroll=OrderHallMissionFrameMissionsListScrollFrame
local OHFMissionScrollChild=OrderHallMissionFrameMissionsListScrollFrameScrollChild
local followerType=LE_FOLLOWER_TYPE_GARRISON_7_0
local garrisonType=LE_GARRISON_TYPE_7_0
local FAKE_FOLLOWERID="0x0000000000000000"
local MAX_LEVEL=110

local ShowTT=OrderHallCommanderMixin.ShowTT
local HideTT=OrderHallCommanderMixin.HideTT

local dprint=print
local ddump
--[===[@debug@
LoadAddOn("Blizzard_DebugTools")
ddump=DevTools_Dump
LoadAddOn("LibDebug")

if LibDebug then LibDebug() dprint=print end
local safeG=addon.safeG

--@end-debug@]===]
--@non-debug@
dprint=function() end
ddump=function() end
local print=function() end
--@end-non-debug@
local LE_FOLLOWER_TYPE_GARRISON_7_0=LE_FOLLOWER_TYPE_GARRISON_7_0
local LE_GARRISON_TYPE_7_0=LE_GARRISON_TYPE_7_0
local GARRISON_FOLLOWER_COMBAT_ALLY=GARRISON_FOLLOWER_COMBAT_ALLY
local GARRISON_FOLLOWER_ON_MISSION=GARRISON_FOLLOWER_ON_MISSION
local GARRISON_FOLLOWER_INACTIVE=GARRISON_FOLLOWER_INACTIVE
local ViragDevTool_AddData=_G.ViragDevTool_AddData
if not ViragDevTool_AddData then ViragDevTool_AddData=function() end end
local KEY_BUTTON1 = "\124TInterface\\TutorialFrame\\UI-Tutorial-Frame:12:12:0:0:512:512:10:65:228:283\124t" -- left mouse button
local KEY_BUTTON2 = "\124TInterface\\TutorialFrame\\UI-Tutorial-Frame:12:12:0:0:512:512:10:65:330:385\124t" -- right mouse button
local CTRL_KEY_TEXT,SHIFT_KEY_TEXT=CTRL_KEY_TEXT,SHIFT_KEY_TEXT


-- End Template - DO NOT MODIFY ANYTHING BEFORE THIS LINE
--*BEGIN
local fake={}
local data={
	ArtifactNotes={
		146745
	},
	U850={
		136412,
		137207,
		137208,

	},
	U880={
		153005,
	},
	U900={
    147348,
    147349,
    147350,
    151842,
	},
	U925={
	 151843
	},
	U950={
		151844,
	},
	Buffs={
		140749,
		143852,
		139419,
		140760,
		140156,
		139428,
		143605,
		139177,
		139420,
		138883,
		139376,
		139418,
		138412,
		140922,
		139670,
		148349,
		148350,
		142209,
	},
	Xp={
		141028
	},
	Equipment={
		139792,
		139795,
		139799,
		139801,
		139802,
		139804,
		139808,
		139809,
		139811,
		139812,
		139813,
		139814,
		139816,
		139819,
		139821,
		139822,
		139823,
		139824,
		139825,
		139826,
		139827,
		139828,
		139829,
		139830,
		139831,
		139832,
		139833,
		139834,
		139835,
		139836,
		139837,
		139838,
		139839,
		139840,
		139841,
		139842,
		139843,
		139844,
		139845,
		139846,
		139847,
		139848,
		139849,
		139850,
		139851,
		139852,
		139853,
		139854,
		139855,
		139856,
		139857,
		139858,
		139859,
		139860,
		139861,
		139862,
		139863,
		139864,
		139865,
		139866,
		139867,
		139868,
		139869,
		139870,
		139871,
		139872,
		139873,
		139874,
		139875,
		139876,
		139877,
		139878,
		140571,
		140572,
		140573,
		140581,
		140582,
		140583,
		145244,
		147552,
		147553,
		147554,
		147555,
		147557,
		147558,
		147559,
		147566,
		147569,
		152437,
		152438,
		152439,
		152440,
		152441,
		152442,
		152443,
		152445,
		152446,
		152447,
		152448,
		152449,
		152450,
		152451,
		152452,
		152453,
		152454,
		152928,
		152929,
		152930,	
    152933,	   
		152934,
		152935,
	},
	ArtifactPower={},
}
local icon2item={}
local itemquality={}
function addon:GetData(key)
	key=key or "none"
	return data[key] or fake
end
local tickle
function module:OnInitialized()
	if addon.allArtifactPower then
		wipe(data.ArtifactPower)
	--[===[@debug@
	addon:Print("Updating artifact with wowhead data")
	--@end-debug@]===]
		for k,_ in pairs(addon.allArtifactPower) do
			tinsert(data.ArtifactPower,todefault(k,1))
		end
	end
	--[===[@debug@
	addon:Print("Starting coroutine")
	--@end-debug@]===]
	addon.coroutineExecute(module,0.1,"TickleServer")
end
function module:AddItem(itemID)

end
function addon:GetItemIdByIcon(iconid)
	return icon2item[iconid]
end
function addon:GetItemQuality(itemId)
	return itemquality[itemId]
end

do
local pairs=pairs
local type=type
local GetItemIcon=GetItemIcon
local GetItemInfo=GetItemInfo
local coroutine=coroutine
local i=0
local failed=1
local iteration=2
local GetTime=GetTime
function tickle(category)
	local start=GetTime()
	for _,itemid in pairs(category) do
		if type(itemid)=="number" and itemid > 10 then
			if not itemquality[itemid] then
				local rc,name,link,quality=pcall(GetItemInfo,itemid)
				if rc and name then
					itemquality[itemid]=quality
					icon2item[GetItemIcon(itemid)]=itemid
					i=i+1
--[===[@debug@
					if i % 100 == 0 then
						addon:Print(format("Precached %d items so far",i))
					end
--@end-debug@]===]
				else
					failed=failed+1
				end
				if coroutine.running() then coroutine.yield() end
			end
		end
	end
end
function module:TickleServer()
	local start=debugprofilestop()
	while true do
		failed=0
		tickle(data.Equipment)
		tickle(data.ArtifactPower)
		tickle(data.Buffs)
		tickle(data.Upgrades)
		tickle(data.Upgrades2)
		tickle(data.Upgrades3)
		iteration=iteration-1
		if failed * iteration == 0 then break end
	end
	--[===[@debug@
	addon:Print(format("Precached %d items in %.3f seconds",i,(debugprofilestop()-start)/1000))
	--@end-debug@]===]
end
end
